//////////////////////////////////////////////////////////////
//                 Declarao de bibliotecas                //
//////////////////////////////////////////////////////////////
#include <Servo.h> //Biblioteca de controle dos servo motores
#include <Ultrasonic.h> //biblioteca de controle do sensor ultrassnico
//////////////////////////////////////////////////////////////
// Fim declarao de bilbliotecas                           //
//////////////////////////////////////////////////////////////

/************************************************************
*************************************************************/
#define tempo 100000000
#define rodou 700
//////////////////////////////////////////////////////////////
// Declaro de servo motores  e sensor ultrason            //
//////////////////////////////////////////////////////////////
Servo coxaEsqFrontal;
Servo coxaEsqMedia;
Servo coxaEsqTrazeira;
Servo coxaDirFrontal;
Servo coxaDirMedia;
Servo coxaDirTrazeira;

Servo tibiaEsqFrontal;
Servo tibiaEsqMedia;
Servo tibiaEsqTrazeira;
Servo tibiaDirFrontal;
Servo tibiaDirMedia;
Servo tibiaDirTrazeira;

Ultrasonic ultrasonic; //Declarao do sensor ultrassnico.

//////////////////////////////////////////////////////////////
// Fim declarao de servo motores  e sensor ultrason       //
//////////////////////////////////////////////////////////////

/************************************************************
*************************************************************/

//////////////////////////////////////////////////////////////
//            Configurao de componentes e portas          //
//////////////////////////////////////////////////////////////
void setup() //funo de configurao do funcionamento da placa arduino e suas portas.
{
  coxaEsqFrontal.attach(30);    //Define pino 30 como pino de controle do servo coxaEsqFrontal
  coxaEsqMedia.attach(31);      //Define pino 31 como pino de controle do servo coxaEsqMedia
  coxaEsqTrazeira.attach(32);   //Define pino 32 como pino de controle do servo coxaEsqTrazeira

  coxaDirFrontal.attach(34);    //Define pino 34 como pino de controle do servo coxaDirFrontal
  coxaDirMedia.attach(35);      //Define pino 35 como pino de controle do servo coxaDirMedia
  coxaDirTrazeira.attach(36);   //Define pino 36 como pino de controle do servo coxaDirTrazeira

  tibiaEsqFrontal.attach(40);   //Define pino 40 como pino de controle do servo tibiaEsqFrontal
  tibiaEsqMedia.attach(41);     //Define pino 41 como pino de controle do servo tibiaEsqMedia
  tibiaEsqTrazeira.attach(42);  //Define pino 41 como pino de controle do servo tibiaEsqTrazeira

  tibiaDirFrontal.attach(44);   //Define pino 44 como pino de controle do servo tibiaDirFrontal
  tibiaDirMedia.attach(45);     //Define pino 45 como pino de controle do servo tibiaDirMedia
  tibiaDirTrazeira.attach(46);  //Define pino 46 como pino de controle do servo tibiaDirTrazeira

  pinMode(13, OUTPUT);          //Define pino como sada de dados para um LED
  pinMode(12, OUTPUT);          //Define pino como sada de dados para um LED
  pinMode(11, OUTPUT);          //Define pino como sada de dados para um LED
  pinMode(10, OUTPUT);          //Define pino como sada de dados para um LED
  pinMode(9, OUTPUT);           //Define pino como sada de dados para um LED

  ultrasonic.attach(52, 53);    // (Trig PIN,Echo PIN)

  Serial.begin(9600);           //Permite a comunicao da placa com o computador para acompanhar a leitura da placa Arduino durante a execuo do programa.
}
//////////////////////////////////////////////////////////////
//         Fim configurao de componentes e placa          //
//////////////////////////////////////////////////////////////

/************************************************************
*************************************************************/

//////////////////////////////////////////////////////////////
//                         Funo main                      //
//////////////////////////////////////////////////////////////
void loop()
{
  int flag = 0;
  // Colocar toda  a estrutura em modo inicial  de 90 e 100.
  coxaEsqFrontal.write(90);
  coxaEsqMedia.write(90);
  coxaEsqTrazeira.write(90);

  coxaDirFrontal.write(90);
  coxaDirMedia.write(90);
  coxaDirTrazeira.write(90);

  tibiaEsqFrontal.write(100);
  tibiaEsqMedia.write(100);
  tibiaEsqTrazeira.write(100);

  tibiaDirFrontal.write(100);
  tibiaDirMedia.write(100);
  tibiaDirTrazeira.write(100);

  digitalWrite(13, LOW); //Desliga o LED na porta 13
  delay(rodou); //Aguarda o tempo definido.
  /************************************************************
  *************************************************************/
  do //Inicia o lao que roda o sistema que controla o rob.
  {
    flag = ultrasonic.Ranging(CM); //Faz a leitura do ambiente e armazena na varivel flag a distncia em CM do objeto a frente.
    //Serial.print(flag);     //Imprime o valor lido na tela do monitor de leitura da IDE Arduino.
    //Serial.println(" CM");  //Imprime  CM na frente do valor lido.
    digitalWrite(9, HIGH); //Liga o LED na porta 9 da placa arduino
    andarFrente();  //Chama a funo que realiza o movimento que simula o andar.
    digitalWrite(9, LOW); //Desliga o LED na porta 9 da placa arduino
  }while(flag>50); //Executa enquanto o valor lido pelo sensor for maior que 50 CM.
}
//////////////////////////////////////////////////////////////
//                     Fim funo main                      //
//////////////////////////////////////////////////////////////

void andarFrente() //Escopo da funo que define o andar.
{
  //>>>>>>> start loop <<<<<<<
  digitalWrite(10, HIGH);       // liga o LED na porta 10.
  tibiaEsqFrontal.write(45);    //sobe
  delay(rodou/2);               //Aguarda o tempo definido.
  coxaEsqFrontal.write(70);     //frente
  delay(rodou/2);               //Aguarda o tempo definido.
  tibiaEsqFrontal.write(100);   //desce
  delay(rodou/2);               //Aguarda o tempo definido.
                                
  tibiaDirFrontal.write(45);    //sobe
  delay(rodou/2);               //Aguarda o tempo definido.
  coxaDirFrontal.write(110);    //frente
  delay(rodou/2);               //Aguarda o tempo definido.
  tibiaDirFrontal.write(100);   //desce
  delay(rodou/2);               //Aguarda o tempo definido.
  digitalWrite(10, LOW);        // desliga o LED na porta 10.

  digitalWrite(12, HIGH);       // liga o LED na porta 12.
  tibiaEsqTrazeira.write(45);   //sobe
  delay(rodou/2);               //Aguarda o tempo definido.
  coxaEsqTrazeira.write(70);    // p/ frente
  delay(rodou/2);               //Aguarda o tempo definido.
  tibiaEsqTrazeira.write(100);  //desce
  delay(rodou/2);               //Aguarda o tempo definido.
                                
  tibiaDirMedia.write(45);      //sobe
  delay(rodou/2);               //Aguarda o tempo definido.
  coxaDirMedia.write(110);      // p/ frente
  delay(rodou/2);               //Aguarda o tempo definido.
  tibiaDirMedia.write(100);     //desce
  delay(rodou/2);               //Aguarda o tempo definido.
  digitalWrite(12, LOW);        // desliga o LED na porta 12.
                                
  digitalWrite(11, HIGH);       // liga o LED na porta 11.
  tibiaEsqMedia.write(45);      //sobe
  delay(rodou/2);               //Aguarda o tempo definido.
  coxaEsqMedia.write(70);       // p/ frente
  delay(rodou/2);               //Aguarda o tempo definido.
  tibiaEsqMedia.write(100);     //desce
  delay(rodou/2);               //Aguarda o tempo definido.
                                
  tibiaDirTrazeira.write(45);   //sobe
  delay(rodou/2);               //Aguarda o tempo definido.
  coxaDirTrazeira.write(110);   // p/ frente
  delay(rodou/2);               //Aguarda o tempo definido.
  tibiaDirTrazeira.write(100);  //sobe
  delay(rodou/2);               //Aguarda o tempo definido.
  digitalWrite(11, LOW);        // desliga o LED na porta 11.
                                
  digitalWrite(12, HIGH);       // liga o LED na porta 12.
  coxaEsqFrontal.write(90);     // p/ frente corpo
  coxaEsqMedia.write(90);       // p/ frente corpo
  coxaEsqTrazeira.write(90);    // p/ frente corpo
                                
  coxaDirFrontal.write(90);     // p/ frente corpo
  coxaDirMedia.write(90);       // p/ frente corpo
  coxaDirTrazeira.write(90);    // p/ frente corpo
  delay(rodou/2);               //Aguarda o tempo definido.
  digitalWrite(12, LOW);        // desliga o LED na porta 12.
  //>>>>>>>> fim loop <<<<<<<<
}
